/* ==========================================================================*/
/* - - - - - - - - - - -  A m b e 2 0 2 0 . H   - - - - - - - - - - - - - -  */
/* ==========================================================================*/
/*    Definition File for the Ambe2020 chip                                  */
/*  Created   2007-07-01	msw                                              */
/*  Modified  2007-07-01    msw                                              */
/* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . */
#ifndef AMBE2020_H_
#define AMBE2020_H_


#define AMBE2020_FRAME_SYNC	0x13EC
#define AMBE2020_IDLE_WORD	0x0000

/*---------------------------------------------------------------------------*/
/*-------------------------> T y p e d e f s <-------------------------------*/
/*---------------------------------------------------------------------------*/

typedef union
{
#pragma pack(1)
	struct
	{
		unsigned short Hdr;
		unsigned short CW1;
		unsigned short Rate0;
		unsigned short Rate1;
		unsigned short Rate2;
		unsigned short Rate3;
		unsigned short Rate4;
		unsigned short Unused1;
		unsigned short Unused2;
		unsigned short Unused3;
		unsigned short DTMFCtrl;
		unsigned short CW2;
		unsigned char ChData[24];
	}fld;
	unsigned short All[24];
}tInFrame;

typedef union
{
#pragma pack(1)
	struct
	{
		unsigned short Hdr;
		unsigned short CW1;
		unsigned short Rate0;
		unsigned short Rate1;
		unsigned short Rate2;
		unsigned short Rate3;
		unsigned short Rate4;
		unsigned short ErrorRate;
		unsigned short ErrorDist;
		unsigned short BitErrors;
		unsigned short DTMFCtrl;
		unsigned short CW2;
		unsigned char ChData[24];
	}fld;
	unsigned short All[24];
	unsigned short AllBytes[48];
}tOutFrame;


#endif /*AMBE2020_H_*/
