// AmbeTestDoc.cpp : implementation of the CAmbeTestDoc class
//

#include "stdafx.h"
#include "AmbeTest.h"

#include "AmbeTestDoc.h"
#include "SerialPort.h"
#include "SoundCard.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


#define MSG_SIZE 0			// define some offsets into msg buffer
#define MSG_TYPE 1
#define MSG_CITEM 2
#define MSG_PARAM 4
#define MSG_FREQ 5
#define MSG_MULT 9
#define MSG_DATAADR 2
#define MSG_DATA 6

#define COM_QSIZE 32768



CSerialPort g_Serial;
CSoundCard g_SoundCard;

/////////////////////////////////////////////////////////////////////////////
// CAmbeTestDoc

IMPLEMENT_DYNCREATE(CAmbeTestDoc, CDocument)

BEGIN_MESSAGE_MAP(CAmbeTestDoc, CDocument)
	//{{AFX_MSG_MAP(CAmbeTestDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAmbeTestDoc construction/destruction

CAmbeTestDoc::CAmbeTestDoc()
{
	// TODO: add one-time construction code here
	m_FileLoaded = FALSE;
	m_FirstTime = TRUE;
	m_Online = FALSE;
	m_Status = RUN_STATUS_IDLE;
	m_RateGroup = 1;
}

CAmbeTestDoc::~CAmbeTestDoc()
{
	g_SoundCard.StopSoundCard();
	if( g_Serial.IsOpen() )
		g_Serial.Close();
}

BOOL CAmbeTestDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	m_FileLoaded = FALSE;
	if(m_FirstTime)
	{
		m_FirstTime = FALSE;
		if(g_ProjectFilePath != "" )
		{
			if(!LoadDataFile(g_ProjectFilePath) )	//load file and check for errors
			{
				SetPathName(g_ProjectFilePath,TRUE);
				m_FileLoaded = TRUE;
			}
			else
			{
				g_ProjectFilePath = "";
			}
		}
		SetModifiedFlag( FALSE);
	}
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CAmbeTestDoc serialization

void CAmbeTestDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}
//////////////////////////////////////////////////////////////////////
// Writes the current program settings into the registry
// so that next time the program is run it can return to this state
//////////////////////////////////////////////////////////////////////
BOOL CAmbeTestDoc::WriteRegistrySettings()
{
CWinApp* pApp = AfxGetApp();
//save ints's
	m_Str.Format("%i", m_ActiveComPort );
	if(!pApp->WriteProfileString("Settings\\Ints", "m_ActiveComPort", m_Str) )
		return FALSE;
	m_Str.Format("%i", m_OutSoundCard );
	if(!pApp->WriteProfileString("Settings\\Ints", "m_OutSoundCard", m_Str) )
		return FALSE;
	m_Str.Format("%i", m_InSoundCard );
	if(!pApp->WriteProfileString("Settings\\Ints", "m_InSoundCard", m_Str) )
		return FALSE;
	m_Str.Format("%i", m_RateGroup );
	if(!pApp->WriteProfileString("Settings\\Ints", "m_RateGroup", m_Str) )
		return FALSE;

//save strings's
	if(!pApp->WriteProfileString("Settings\\Strings", "m_OutFilePathStr", m_OutFilePathStr))
		return FALSE;
	return TRUE;
}

//////////////////////////////////////////////////////////////////////
//Reads all the program settings from the last session from the registry
//////////////////////////////////////////////////////////////////////
BOOL CAmbeTestDoc::ReadRegistrySettings()
{
CWinApp* pApp = AfxGetApp();
int cRead;
//Get ints's
	m_Str = pApp->GetProfileString ("Settings\\Ints", "m_ActiveComPort");
	cRead = _stscanf (m_Str, "%i", &m_ActiveComPort );
	if(cRead != 1)
		m_ActiveComPort = 1;
	m_Str = pApp->GetProfileString ("Settings\\Ints", "m_OutSoundCard");
	cRead = _stscanf (m_Str, "%i", &m_OutSoundCard );
	if(cRead != 1)
		m_OutSoundCard = 0;
	m_Str = pApp->GetProfileString ("Settings\\Ints", "m_InSoundCard");
	cRead = _stscanf (m_Str, "%i", &m_InSoundCard );
	if(cRead != 1)
		m_InSoundCard = 0;
	m_Str = pApp->GetProfileString ("Settings\\Ints", "m_RateGroup");
	cRead = _stscanf (m_Str, "%i", &m_RateGroup );
	if(cRead != 1)
		m_RateGroup = 1;
	
	
//get strings
	m_OutFilePathStr = pApp->GetProfileString("Settings\\Strings", "m_OutFilePathStr",_T("c:\\"));

	return TRUE;
}
/////////////////////////////////////////////////////////////////////////////
// CAmbeTestDoc diagnostics

#ifdef _DEBUG
void CAmbeTestDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CAmbeTestDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAmbeTestDoc commands
BOOL CAmbeTestDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
BOOL ret;
CString Path = lpszPathName;
	SetModifiedFlag( FALSE);
	ret = LoadDataFile(Path);	//load file and check for errors
	if(ret)
	{
		m_FileLoaded = FALSE;
	}
	else
	{
		g_ProjectFilePath = Path;
		SetPathName(g_ProjectFilePath,TRUE);
		m_FileLoaded = TRUE;
	}
	return !ret;
}

void CAmbeTestDoc::OnCloseDocument() 
{
	WriteRegistrySettings();
	CDocument::OnCloseDocument();
}

BOOL CAmbeTestDoc::LoadDataFile(CString path)
{
	return FALSE;

}

void CAmbeTestDoc::GetInSoundData( int* pBuf)
{
	for(int i=0; i<MAX_DISPLAY_BUFSIZE ;i++)
		pBuf[i] = g_SoundCard.m_InDisplayBuf[i];
}

void CAmbeTestDoc::GetOutSoundData( int* pBuf)
{
	for(int i=0; i<MAX_DISPLAY_BUFSIZE ;i++)
		pBuf[i] = g_SoundCard.m_OutDisplayBuf[i];

}

//////////////////////////////////////////////////////////////////////
//  Called to start worker threads that manage the serial port and soundcard
//////////////////////////////////////////////////////////////////////
void CAmbeTestDoc::StartThreads() 
{
//start up serial port and thread
	m_Str.Format("\\\\.\\COM%d", m_ActiveComPort);
	long result = g_Serial.Open( m_Str, COM_QSIZE, COM_QSIZE, FALSE);
	if(result != ERROR_SUCCESS)
	{
		return;
	}
	result = g_Serial.Setup(   CSerial::EBaud230400,	//set up COM parms
								CSerial::EData8,
								CSerial::EParNone,
								CSerial::EStop1);
	if(result != ERROR_SUCCESS)
	{
		g_Serial.Close();
		return;
	}
	g_Serial.SetupReadTimeouts(CSerial::EReadTimeoutNonblocking);
	g_Serial.SetupHandshaking( CSerial::EHandshakeOff);
	g_Serial.SetMask(CSerial::EEventRecv | 
							CSerial::EEventError
							);
	g_Serial.StartListener(m_RateGroup);
	SendStart();
//Now start up soundcard thread
	int error = g_SoundCard.StartSoundCard(m_InSoundCard, m_OutSoundCard);
	if(error)
	{
		if( g_Serial.IsOpen() )
			g_Serial.Close();
		return;
	}
	m_Online = TRUE;
}

//////////////////////////////////////////////////////////////////////
//  Called to stop serial port, soundcard, and worker threads
//////////////////////////////////////////////////////////////////////
void CAmbeTestDoc::StopThreads() 
{
	SendStop();
	if( g_Serial.IsOpen() )
	{
		g_Serial.Purge();
		g_Serial.Close();
	}
	g_SoundCard.StopSoundCard();
	m_Online = FALSE;
}



void CAmbeTestDoc::SendStart()
{
	g_Serial.m_TxASCPmsg.citem.header = CI_RUN_STATE_REQLEN;
	g_Serial.m_TxASCPmsg.base.h1 |= TYPE_HOST_SET_CITEM;
	g_Serial.m_TxASCPmsg.citem.CItem = CI_RUN_STATE;
	g_Serial.m_TxASCPmsg.citem.parms[0] = 1;
	g_Serial.SendASCPMsg(&g_Serial.m_TxASCPmsg);

	g_Serial.m_TxASCPmsg.citem.header = CI_GENERAL_INTERFACE_SERIALNUM_REQLEN;
	g_Serial.m_TxASCPmsg.base.h1 |= TYPE_HOST_REQ_CITEM;
	g_Serial.m_TxASCPmsg.citem.CItem = CI_GENERAL_INTERFACE_SERIALNUM;
	g_Serial.SendASCPMsg(&g_Serial.m_TxASCPmsg);

	m_Status = RUN_STATUS_RUNNING;
}

void CAmbeTestDoc::SendStop()
{
	g_Serial.m_TxASCPmsg.citem.header = CI_RUN_STATE_REQLEN;
	g_Serial.m_TxASCPmsg.base.h1 |= TYPE_HOST_SET_CITEM;
	g_Serial.m_TxASCPmsg.citem.CItem = CI_RUN_STATE;
	g_Serial.m_TxASCPmsg.citem.parms[0] = 0;
	g_Serial.SendASCPMsg(&g_Serial.m_TxASCPmsg);
	m_Status = RUN_STATUS_IDLE;
}
