// AmbeTestView.cpp : implementation of the CAmbeTestView class
//

#include "stdafx.h"
#include "AmbeTest.h"
#include "mainfrm.h"

#include "AmbeTestDoc.h"
#include "AmbeTestView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



#define ID_TIMER 10

/////////////////////////////////////////////////////////////////////////////
// CAmbeTestView

IMPLEMENT_DYNCREATE(CAmbeTestView, CResizableFormView)

BEGIN_MESSAGE_MAP(CAmbeTestView, CResizableFormView)
	//{{AFX_MSG_MAP(CAmbeTestView)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_ONLINEBUTTON, OnOnlinebutton)
	ON_BN_CLICKED(IDC_RECORDCHECK, OnRecordcheck)
	ON_BN_CLICKED(IDC_VOICEBUTTON, OnVoicebutton)
	ON_WM_DESTROY()
	ON_NOTIFY(UDN_DELTAPOS, IDC_BITERRSPIN, OnDeltaposBiterrspin)
	ON_BN_CLICKED(IDC_SAVEBUTTON, OnSavebutton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAmbeTestView construction/destruction

CAmbeTestView::CAmbeTestView()
	: CResizableFormView(CAmbeTestView::IDD)
{
	//{{AFX_DATA_INIT(CAmbeTestView)
	m_DTMFActive = FALSE;
	m_Recording = FALSE;
	m_RateGroup = -1;
	//}}AFX_DATA_INIT
	// TODO: add construction code here
	m_AlreadyInitialized = FALSE;
	m_pCPlotData = NULL;
}

CAmbeTestView::~CAmbeTestView()
{
	if(m_pCPlotData)
	{
		delete m_pCPlotData;
	}		
}

void CAmbeTestView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAmbeTestView)
	DDX_Control(pDX, IDC_BITERRSPINTXT, m_BitErrTxtCtrl);
	DDX_Control(pDX, IDC_TESTTXT, m_TestTxtCtrl);
	DDX_Control(pDX, IDC_ONLINEBUTTON, m_OnLineButtonCtrl);
	DDX_Check(pDX, IDC_DTMFCHECK, m_DTMFActive);
	DDX_Check(pDX, IDC_RECORDCHECK, m_Recording);
	DDX_Radio(pDX, IDC_RATERADIO, m_RateGroup);
	//}}AFX_DATA_MAP
	DDX_Control(pDX, IDC_CLOCK, m_ClockCtrl);
	DDX_Control(pDX, IDC_STATUSCTRL, m_StatusCtrl);
}

BOOL CAmbeTestView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

void CAmbeTestView::OnInitialUpdate()
{

CAmbeTestDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	if(	!m_AlreadyInitialized )
	{
		//instantiate display data plotting and processing  objects
		if(!m_pCPlotData)
			m_pCPlotData = new CPlotData();	//initialize Data plotting resources
		m_AlreadyInitialized = TRUE;
		AddAnchor(IDC_ONLINEBUTTON, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_STATUSCTRL, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_CLOCK, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_DTMFCHECK, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_RECORDCHECK, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_VOICEBUTTON, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_SAVEBUTTON, BOTTOM_CENTER, NOANCHOR);

		AddAnchor(IDC_INPLOT, TOP_LEFT, BOTTOM_CENTER);
		AddAnchor(IDC_OUTPLOT, TOP_CENTER, BOTTOM_RIGHT );

		AddAnchor(IDC_TESTTXT, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_BITERRSPINTXT, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_BITERRSPIN, BOTTOM_CENTER, NOANCHOR);
		
		AddAnchor(IDC_RATEGROUP, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_RATERADIO, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_RATERADIO2400, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_RATERADIO4800, BOTTOM_CENTER, NOANCHOR);
		AddAnchor(IDC_RATERADIO9600, BOTTOM_CENTER, NOANCHOR);
		
		
		CResizableFormView::OnInitialUpdate();
		
		m_TimerID = SetTimer(ID_TIMER,100,NULL);	//status update timer
		pDoc->ReadRegistrySettings();
		m_ClockCtrl.SetTextColor( RGB(64,64,128) );
		m_StatusCtrl.SetLEDColor( RGB( 255, 0, 0) );
	}
	CMainFrame* pFrm=(CMainFrame*)AfxGetMainWnd();
	pFrm->StayOnTop();	
	m_RateGroup = pDoc->m_RateGroup;
	m_BitErrors = 0;
	m_Str.Format("Errors = %d", m_BitErrors);
	m_BitErrTxtCtrl.SetWindowText(m_Str);
	g_Serial.SetBitErrors(m_BitErrors );
	m_LastStatus = !pDoc->m_Status;
	ValidateControls();
	CResizableFormView::OnInitialUpdate();
	GetParentFrame()->RecalcLayout();
	ResizeParentToFit();
}

/////////////////////////////////////////////////////////////////////////////
// CAmbeTestView diagnostics

#ifdef _DEBUG
void CAmbeTestView::AssertValid() const
{
	CResizableFormView::AssertValid();
}

void CAmbeTestView::Dump(CDumpContext& dc) const
{
	CResizableFormView::Dump(dc);
}

CAmbeTestDoc* CAmbeTestView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAmbeTestDoc)));
	return (CAmbeTestDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAmbeTestView message handlers

void CAmbeTestView::OnDraw(CDC* pDC) 
{
CAmbeTestDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	//go recalculate & draw the data plots
	if(m_pCPlotData)
	{
		m_pCPlotData->OnDrawPlot( m_hWnd, this, pDoc );
	}
}


void CAmbeTestView::OnDestroy() 
{
CAmbeTestDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	pDoc->m_RateGroup = m_RateGroup;
	KillTimer(m_TimerID);
	CResizableFormView::OnDestroy();
	pDoc->SendStop();
	Sleep(100);
	pDoc->StopThreads();
	
}


void CAmbeTestView::OnTimer(UINT nIDEvent) 
{
CAmbeTestDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	if(nIDEvent == m_TimerID )
	{
		ValidateControls();
		if(	pDoc->m_Online )
		{
			m_OnLineButtonCtrl.SetWindowText("Stop");
			switch(pDoc->m_Status)
			{
				case RUN_STATUS_IDLE:
					m_Str.Format("Idle");
					m_StatusCtrl.SetLEDColor( RGB( 0, 255, 0) );
					break;
				case RUN_STATUS_RUNNING:
					m_pCPlotData->DrawPlot();
					if(m_Recording)
					{
						m_Str.Format("Recording"); 
						m_StatusCtrl.SetLEDColor( RGB( 255, 0, 255) );
					}
					else
					{
						m_Str.Format("Running  SN=");
						m_Str += g_Serial.m_SerialNumber;
						if(g_Serial.m_VoiceDetect)
							m_StatusCtrl.SetLEDColor( RGB( 0, 255, 0) );
						else
							m_StatusCtrl.SetLEDColor( RGB( 255, 255, 0) );
					}
					m_StatusCtrl.SetPos(g_Serial.GetProgress());
					break;
				case RUN_STATUS_ERROR:
					m_Str.Format("Error");
					m_StatusCtrl.SetLEDColor( RGB( 255, 0, 0) );
					break;
			}
		}else
		{
			m_OnLineButtonCtrl.SetWindowText("Start");
			m_Str.Format("OffLine");
			m_StatusCtrl.SetLEDColor( RGB( 255, 0, 0) );
		}
		m_StatusCtrl.SetText(m_Str);
		m_Str.Format("Rate Delta %d %d  RxErr %d",g_SoundCard.m_DeltaInAve, g_SoundCard.m_DeltaOutAve, g_Serial.GetBitErrors() ); 
		m_TestTxtCtrl.SetWindowText(m_Str);
		ServiceDTMFGen();
	}	
	CResizableFormView::OnTimer(nIDEvent);
}

void CAmbeTestView::OnOnlinebutton() 
{
CAmbeTestDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	UpdateData(TRUE);
	pDoc->m_RateGroup = m_RateGroup;
	if(	pDoc->m_Online )
	{
		if( RUN_STATUS_RUNNING == pDoc->m_Status)
		{
			pDoc->SendStop();
			Sleep(50);
		}
		pDoc->StopThreads();
	}
	else
	{
		pDoc->StartThreads();
	}
}

void CAmbeTestView::OnRunbutton() 
{
CAmbeTestDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	if(	pDoc->m_Online )
	{
		if( RUN_STATUS_IDLE == pDoc->m_Status)
			pDoc->SendStart();
		else if( RUN_STATUS_RUNNING == pDoc->m_Status)
			pDoc->SendStop();
	}
}

void CAmbeTestView::ServiceDTMFGen()
{
	UpdateData(TRUE);
	if(m_DTMFActive)
	{
		m_DTMFTimer++;
		if(m_DTMFTimer&1)
		{
			g_Serial.SetTouchTone( TRUE, m_DTMFDigit++);
			if( m_DTMFDigit > '9')
				m_DTMFDigit = '0';
		}
		else
		{
			g_Serial.SetTouchTone(TRUE, ' ');
		}
	}
	else
	{
		g_Serial.SetTouchTone(FALSE, ' ');
		m_DTMFDigit = '0';
	}
}

void CAmbeTestView::OnRecordcheck() 
{
	UpdateData(TRUE);
	if(m_Recording)
		g_Serial.SetRecordingState(TRUE);
	else
		g_Serial.SetRecordingState(FALSE);
	
}

void CAmbeTestView::OnVoicebutton() 
{
	g_Serial.CannedVoice();
}



void CAmbeTestView::OnDeltaposBiterrspin(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_UPDOWN* pNMUpDown = (NM_UPDOWN*)pNMHDR;
	m_BitErrors = m_BitErrors - pNMUpDown->iDelta;
	if( m_BitErrors < 0)
		m_BitErrors = 0;
	if( m_BitErrors > 50)
		m_BitErrors = 50;
	m_Str.Format("Errors = %d",m_BitErrors);
	m_BitErrTxtCtrl.SetWindowText(m_Str);
	g_Serial.SetBitErrors(m_BitErrors );
	*pResult = 0;
}

void CAmbeTestView::OnSavebutton() 
{
CAmbeTestDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	g_Serial.SaveToWaveFile(pDoc->m_OutFilePathStr);	
}

void CAmbeTestView::ValidateControls()
{
CAmbeTestDoc* pDoc = GetDocument();
	ASSERT_VALID( pDoc );
	if(m_LastStatus != pDoc->m_Status)
	{
		m_LastStatus = pDoc->m_Status;
		if( RUN_STATUS_RUNNING == pDoc->m_Status)
		{
			GetDlgItem( IDC_RATERADIO )->EnableWindow(FALSE);
			GetDlgItem( IDC_RATERADIO2400 )->EnableWindow(FALSE);
			GetDlgItem( IDC_RATERADIO4800 )->EnableWindow(FALSE);
			GetDlgItem( IDC_RATERADIO9600 )->EnableWindow(FALSE);
			GetDlgItem( IDC_RECORDCHECK )->EnableWindow(TRUE);
			GetDlgItem( IDC_VOICEBUTTON )->EnableWindow(TRUE);
			GetDlgItem( IDC_SAVEBUTTON )->EnableWindow(TRUE);
			GetDlgItem( IDC_DTMFCHECK )->EnableWindow(TRUE);
		}
		else
		{
			GetDlgItem( IDC_RATERADIO )->EnableWindow(TRUE);
			GetDlgItem( IDC_RATERADIO2400 )->EnableWindow(TRUE);
			GetDlgItem( IDC_RATERADIO4800 )->EnableWindow(TRUE);
			GetDlgItem( IDC_RATERADIO9600 )->EnableWindow(TRUE);
			GetDlgItem( IDC_RECORDCHECK )->EnableWindow(FALSE);
			GetDlgItem( IDC_VOICEBUTTON )->EnableWindow(FALSE);
			GetDlgItem( IDC_SAVEBUTTON )->EnableWindow(FALSE);
			GetDlgItem( IDC_DTMFCHECK )->EnableWindow(FALSE);
		}
		
	}
}
