// Clock.cpp : implementation file
//

#include "stdafx.h"
#include "Clock.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define ID_TIMER 6

/////////////////////////////////////////////////////////////////////////////
// CClock

CClock::CClock()
{
    RegisterWindowClass();
}

CClock::~CClock()
{
}

// Register the window class if it has not already been registered.
BOOL CClock::RegisterWindowClass()
{
    WNDCLASS wndcls;
    HINSTANCE hInst = AfxGetInstanceHandle();

    if (!(::GetClassInfo(hInst, CCLOCK_CLASSNAME, &wndcls)))
    {
        // otherwise we need to register a new class
        wndcls.style            = CS_DBLCLKS | CS_HREDRAW | CS_VREDRAW;
        wndcls.lpfnWndProc      = ::DefWindowProc;
        wndcls.cbClsExtra       = wndcls.cbWndExtra = 0;
        wndcls.hInstance        = hInst;
        wndcls.hIcon            = NULL;
        wndcls.hCursor          = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
        wndcls.hbrBackground    = (HBRUSH) (COLOR_3DFACE + 1);
        wndcls.lpszMenuName     = NULL;
        wndcls.lpszClassName    = CCLOCK_CLASSNAME;

        if (!AfxRegisterClass(&wndcls))
        {
            AfxThrowResourceException();
            return FALSE;
        }
    }

    return TRUE;
}

BEGIN_MESSAGE_MAP(CClock, CWnd)
	//{{AFX_MSG_MAP(CClock)
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CClock::Create( DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID /*=WS_VISIBLE*/)
{
	return CWnd::Create(CCLOCK_CLASSNAME, _T(""), dwStyle, rect, pParentWnd, nID);
}

/////////////////////////////////////////////////////////////////////////////
// CClock message handlers
void CClock::PreSubclassWindow() 
{
	m_LocalFormat = TRUE;
	m_BkColor = GetSysColor(COLOR_BTNFACE);
	m_TextColor = GetSysColor(COLOR_BTNTEXT);
	m_TimeStr = "";
	m_TimerID = SetTimer( ID_TIMER, 900, NULL);	//start up update timer
//	if( m_TimerID == 0)
//		AfxMessageBox( "Can't Start Timer",MB_OK );
	
	CWnd::PreSubclassWindow();
}

void CClock::OnPaint() 
{
CFont *pFontOld ;
TEXTMETRIC tm ;
	CPaintDC dc(this); // device context for painting
	
        // Get Size of Display area
	CRect rect;
	GetClientRect(rect);

	m_fontValue.DeleteObject() ;
	m_fontValue.CreateFont((90*rect.Height())/100, 0, 0, 0, FW_REGULAR,
												  FALSE, FALSE, 0, ANSI_CHARSET,
												  OUT_DEFAULT_PRECIS, 
												  CLIP_DEFAULT_PRECIS,
												  DEFAULT_QUALITY, 
												  DEFAULT_PITCH|FF_MODERN, "Arial") ;

	// Now select this font and calculate the 
	// actual height to see what Windows gave us.
	pFontOld = dc.SelectObject(&m_fontValue);
	dc.GetTextMetrics(&tm);
	int m_nValueFontHeight = tm.tmHeight;

	// determine the location for the value within
	// the rectangele based on the font height
	int m_nValueCenter = rect.left + rect.Width()/2 ;

	// now we need to use the font to draw some text
	// set the colors 
	dc.SetTextAlign(TA_CENTER|TA_BOTTOM);
	dc.SetTextColor( m_TextColor );
	dc.SetBkColor( m_BkColor );
	dc.TextOut(m_nValueCenter, m_nValueFontHeight, m_TimeStr) ;

	// Do not call CWnd::OnPaint() for painting messages
}

void CClock::OnTimer(UINT nIDEvent) 
{
// Get current time and date
	CTime time = CTime::GetCurrentTime();
	if(m_LastTime != time)
	{
		m_LastTime = time;
		if(m_LocalFormat)
			m_TimeStr = time.Format(_T(" %a %#d %b %Y  %#I:%M:%S %p "));
		else
			m_TimeStr = time.FormatGmt(_T(" %#d %b %Y  %#H:%M:%S UTC "));
		if( m_TimerID == ID_TIMER)
			InvalidateRect(NULL);
	}
	CWnd::OnTimer(nIDEvent);
}

void CClock::OnDestroy() 
{
	CWnd::OnDestroy();
	
	if( m_TimerID == ID_TIMER)
	{
		KillTimer(m_TimerID);
		m_TimerID = NULL;
	}
	
}
