// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "AmbeTest.h"
#include "AmbeTestDoc.h"
#include "AmbeTestView.h"
#include "Htmlhelp.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////  Global Variables ///////////////////
CString g_ProjectFilePath = "";
CString g_ExePath = "";

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	ON_COMMAND(IDM_STAYONTOP, OnStayontop)
	ON_UPDATE_COMMAND_UI(IDM_STAYONTOP, OnUpdateStayontop)
	ON_COMMAND(IDM_PORTSETUP, OnPortsetup)
	ON_COMMAND(IDM_SOUNDCARDSETUP, OnSoundcardsetup)
	ON_COMMAND(IDM_WAVESETUP, OnWavesetup)
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	m_wp.length = sizeof(WINDOWPLACEMENT);
	if( !LoadWindowPlacement( &m_wp ) )
	{
		// set default sizes if none are loaded from the registry
		m_wp.length = 0;
		m_StayOnTop = FALSE;
	}
	//get last project file path from registry if it exists
	// else NULL if doesnt exist. Will fill in when CDocuments's OnNewDocument() is called
	g_ProjectFilePath = AfxGetApp()->GetProfileString("FilePaths", "g_ProjectFilePath", "");
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}


void CMainFrame::ActivateFrame(int nCmdShow) 
{
	if(	m_wp.length != 0)	//if structure has been filled in
	{
		nCmdShow= m_wp.showCmd;
		AfxGetApp ()->m_nCmdShow = nCmdShow;
		SetWindowPlacement(&m_wp);
	}
	else
		AfxGetApp ()->m_nCmdShow = nCmdShow;	
	
	CFrameWnd::ActivateFrame(nCmdShow);
}


void CMainFrame::OnClose() 
{
CAmbeTestDoc* pDoc = (CAmbeTestDoc*)CMainFrame::GetActiveDocument();
	ASSERT_VALID(pDoc);
	CAmbeTestView *pView = (CAmbeTestView *)GetActiveView();
	pView->UpdateData(TRUE);
	pDoc->m_RateGroup = pView->m_RateGroup;

	AfxGetApp()->WriteProfileString("FilePaths", "g_ProjectFilePath", g_ProjectFilePath);
	WINDOWPLACEMENT wp;
	wp.length = sizeof(WINDOWPLACEMENT);
	if (GetWindowPlacement(&wp) )
	{
		if( IsZoomed() )
			wp.flags |= WPF_RESTORETOMAXIMIZED;
		SaveWindowPlacement( &wp );
	}
	
	CFrameWnd::OnClose();
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG
///////////////////////////////////////////////////////////////
// get registry screen size settings
///////////////////////////////////////////////////////////////
BOOL CMainFrame::LoadWindowPlacement(LPWINDOWPLACEMENT pwp)
{
	CString strBuffer = AfxGetApp ()->GetProfileString ("WindowPos", "WindowPos");
	if (strBuffer.IsEmpty ())
		return FALSE;
	int cRead = _stscanf (strBuffer, "%i:%i:%i:%i:%i:%i:%i:%i:%i:%i",
			&pwp->flags, &pwp->showCmd,
			&pwp->ptMinPosition.x, &pwp->ptMinPosition.y,
			&pwp->ptMaxPosition.x, &pwp->ptMaxPosition.y,
			&pwp->rcNormalPosition.left, &pwp->rcNormalPosition.top,
			&pwp->rcNormalPosition.right, &pwp->rcNormalPosition.bottom);

	if(pwp->flags & 0x8000)
		m_StayOnTop = TRUE;
	else
		m_StayOnTop = FALSE;
	pwp->flags &= ~0x8000;

	if (cRead != 10)
		return FALSE;
	return TRUE;
}

///////////////////////////////////////////////////////////////
// save screen size settings to registry
///////////////////////////////////////////////////////////////
void CMainFrame::SaveWindowPlacement(LPWINDOWPLACEMENT pwp)
{
	// SaveWindowPlacement
	if(m_StayOnTop)
		pwp->flags |= 0x8000;
	else
		pwp->flags &= ~0x8000;
	CString strBuffer;
	strBuffer.Format ("%i:%i:%i:%i:%i:%i:%i:%i:%i:%i",
		pwp->flags, pwp->showCmd,
		pwp->ptMinPosition.x, pwp->ptMinPosition.y,
		pwp->ptMaxPosition.x, pwp->ptMaxPosition.y,
		pwp->rcNormalPosition.left, pwp->rcNormalPosition.top,
		pwp->rcNormalPosition.right, pwp->rcNormalPosition.bottom);

	AfxGetApp()->WriteProfileString("WindowPos", "WindowPos", strBuffer);
}

void CMainFrame::WinHelp(DWORD dwData, UINT nCmd) 
{
CWinApp* theApp = AfxGetApp();
CString helpFilePath = theApp->m_pszHelpFilePath;
	switch(nCmd)
	{
		case HELP_FINDER:
			HtmlHelp( m_hWnd, helpFilePath, HH_DISPLAY_TOPIC, dwData);
			break;
		case HELP_CONTEXT:
			HtmlHelp( m_hWnd, helpFilePath, HH_DISPLAY_TOPIC, dwData);
			break;
		default:
			break;
	}
}

BOOL CMainFrame::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	return TRUE;
}


/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::StayOnTop()
{
CWnd* pWnd = AfxGetMainWnd();
	ASSERT_VALID(pWnd);
	pWnd->SetWindowPos( (m_StayOnTop) ? &wndTopMost : &wndNoTopMost,
						0,0,0,0, SWP_NOMOVE|SWP_NOSIZE);
}


void CMainFrame::OnStayontop() 
{
	if(	m_StayOnTop )
		m_StayOnTop = FALSE;
	else
		m_StayOnTop = TRUE;
	StayOnTop();
		
}

void CMainFrame::OnUpdateStayontop(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_StayOnTop);
	
}

void CMainFrame::OnPortsetup() 
{
CAmbeTestDoc* pDoc = (CAmbeTestDoc*)CMainFrame::GetActiveDocument();
	ASSERT_VALID(pDoc);
CComDlg dlg;
	dlg.m_pDoc = pDoc;
	dlg.m_ActiveComPort = pDoc->m_ActiveComPort;
	if( IDOK == dlg.DoModal() )
	{
		pDoc->m_ActiveComPort = dlg.m_ActiveComPort;
	}
}

void CMainFrame::OnSoundcardsetup() 
{
CAmbeTestDoc* pDoc = (CAmbeTestDoc*)CMainFrame::GetActiveDocument();
	ASSERT_VALID(pDoc);
CSoundCardDlg dlg;
	dlg.m_OutSoundCard = pDoc->m_OutSoundCard;
	dlg.m_InSoundCard = pDoc->m_InSoundCard;
	if( IDOK == dlg.DoModal() )
	{
		pDoc->m_OutSoundCard = dlg.m_OutSoundCard;
		pDoc->m_InSoundCard = dlg.m_InSoundCard;
	}
}

void CMainFrame::OnWavesetup() 
{
//  handler code here for getting .wav output filename
CFile file;
CAmbeTestDoc* pDoc = (CAmbeTestDoc*)CMainFrame::GetActiveDocument();
	ASSERT_VALID(pDoc);
CString sFilter = "Wave Files (*.wav)|*.wav||";
CString path;
	if( 0 != file.Open(pDoc->m_OutFilePathStr,CFile::modeRead) )
		path = pDoc->m_OutFilePathStr;
	else
		path = "";
CFileDialog Dlgfile( FALSE, "wav", path, 
			OFN_HIDEREADONLY, (LPCTSTR)sFilter, this );
	if( Dlgfile.DoModal() == IDOK)
	{
		pDoc->m_OutFilePathStr = Dlgfile.GetPathName();
	}		
}
