// SoundCard.h: interface for the CSoundCard class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SOUNDCARD_H__FFEE5116_7546_40B7_81EF_9F43B5494B0A__INCLUDED_)
#define AFX_SOUNDCARD_H__FFEE5116_7546_40B7_81EF_9F43B5494B0A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Sound.h"

#define MAX_DISPLAY_BUFSIZE 2048
#define DATA_BUFSIZE 160
#define RINGBUF_SIZE 16		//keep power of 2

typedef struct
{
	short Buf[DATA_BUFSIZE];
}tRingBuf;

class CSoundCard  
{
public:
	CSoundCard();
	virtual ~CSoundCard();
	int StartSoundCard(int Incard, int Outcard);
	void StopSoundCard();

	void PutSoundOutData( SHORT* pData );
	void GetSoundInData( SHORT* pData );

	int m_InDisplayBuf[MAX_DISPLAY_BUFSIZE];
	int m_OutDisplayBuf[MAX_DISPLAY_BUFSIZE];
	BOOL m_ThreadsRunning;
	int m_DeltaInAve;
	int m_DeltaOutAve;

private:
	int m_OutCard;
	int m_InCard;
	void Close();
	void SndInThread();
	static UINT SndInThreadProc(LPVOID pParam);	//must be static since is thread
	CWinThread *m_pSndInThread;
	void SndOutThread();
	static UINT SndOutThreadProc(LPVOID pParam);	//must be static since is thread
	CWinThread *m_pSndOutThread;

	UINT OpenOutput(int Card );
	UINT OpenInput(int Card );

	WAVEFORMATEX m_InWFX;
	WAVEFORMATEX m_OutWFX;
	int m_DeltaIn;
	int m_DeltaInSum;
	int m_DeltaOut;
	int m_DeltaOutSum;
	int m_InDispPtr;
	int m_OutDispPtr;
	tRingBuf m_InBuf[RINGBUF_SIZE];
	tRingBuf m_OutBuf[RINGBUF_SIZE];
	int m_InBufHead;
	int m_InBufTail;
	int m_OutBufHead;
	int m_OutBufTail;
	CSound m_Sound;
};

#endif // !defined(AFX_SOUNDCARD_H__FFEE5116_7546_40B7_81EF_9F43B5494B0A__INCLUDED_)
