// StatusCntrl.cpp : implementation file
/************************************************************************
   DESCRIPTION: 
   REVISION HISTORY:
 *
 * original

   NOTES:

    Copyright 2005
	Digitrax, Inc
	450 Cemetery Street
	Suite #206
	Norcross, Georgia, 30071
    USA

    This software contains valuable trade secrets and proprietary information
    of Digitrax, Inc and is protected by law. It may not be copied or
    distributed in any form or medium, disclosed to third parties, reverse
    engineered or used in any manner without prior written authorization
    from Digitrax, Inc.
 ************************************************************************/
//

#include "stdafx.h"
#include "StatusCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStatusCtrl

CStatusCtrl::CStatusCtrl()
{
    RegisterWindowClass();
}

CStatusCtrl::~CStatusCtrl()
{
}

// Register the window class if it has not already been registered.
BOOL CStatusCtrl::RegisterWindowClass()
{
    WNDCLASS wndcls;
    HINSTANCE hInst = AfxGetInstanceHandle();

    if (!(::GetClassInfo(hInst, CSTATUSCTRL_CLASSNAME, &wndcls)))
    {
        // otherwise we need to register a new class
        wndcls.style            = CS_HREDRAW | CS_VREDRAW;
        wndcls.lpfnWndProc      = ::DefWindowProc;
        wndcls.cbClsExtra       = wndcls.cbWndExtra = 0;
        wndcls.hInstance        = hInst;
        wndcls.hIcon            = NULL;
        wndcls.hCursor          = AfxGetApp()->LoadStandardCursor(IDC_ARROW);
        wndcls.hbrBackground    = (HBRUSH) (COLOR_3DFACE + 1);
        wndcls.lpszMenuName     = NULL;
        wndcls.lpszClassName    = CSTATUSCTRL_CLASSNAME;

        if (!AfxRegisterClass(&wndcls))
        {
            AfxThrowResourceException();
            return FALSE;
        }
    }

    return TRUE;
}

BEGIN_MESSAGE_MAP(CStatusCtrl, CWnd)
	//{{AFX_MSG_MAP(CStatusCtrl)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BOOL CStatusCtrl::Create( DWORD dwStyle, const RECT& rect,
							CWnd* pParentWnd, UINT nID)
{
	return CWnd::Create(CSTATUSCTRL_CLASSNAME, _T(""), dwStyle, rect, pParentWnd, nID);

//	return CWnd::CreateEx(WS_EX_CLIENTEDGE | WS_EX_STATICEDGE,
//							CSTATUSCTRL_CLASSNAME, lpszWindowName, dwStyle,
//							rect.left,rect.top,rect.right-rect.left,rect.bottom-rect.top,
//							pParentWnd->GetSafeHwnd(), (HMENU)nID);
}

void CStatusCtrl::SetRange(UINT nLower, UINT nUpper)
{
	ASSERT( nLower>=0 && nLower <= 0x7FFFFFF );
	ASSERT( nUpper>=nLower && nUpper <= 0x7FFFFFFF );
	m_nLower = nLower;
	m_nUpper = nUpper;
}

UINT CStatusCtrl::SetPos(UINT nPos)
{
//	ASSERT( nPos >= m_nLower && nPos<=m_nUpper);
	if( nPos < m_nLower)
		nPos = m_nLower;
	if( nPos > m_nUpper)
		nPos = m_nUpper;
	UINT nOld = m_nPos;
	m_nPos = nPos;
	InvalidateCntrl();
	return nOld;
}

void CStatusCtrl::SetText(CString str)
{
	m_TextString = str;
	InvalidateCntrl();
}

void CStatusCtrl::SetBarColor(COLORREF cr)
{
	m_BarColor = cr;
	InvalidateCntrl();
}
void CStatusCtrl::SetBkColor(COLORREF cr)
{
	m_BkColor = cr;
	InvalidateCntrl();
}
void CStatusCtrl::SetTextColor(COLORREF cr)
{
	m_TxtColor = cr;
	InvalidateCntrl();
}
void CStatusCtrl::SetLEDColor(COLORREF cr)
{
	m_LEDColor = cr;
	InvalidateCntrl();
}

void CStatusCtrl::InvalidateCntrl()
{
	CRect r;
	GetClientRect(r);
	InvalidateRect(r);
}

/////////////////////////////////////////////////////////////////////////////
// CStatusCtrl message handlers
void CStatusCtrl::PreSubclassWindow() 
{
	m_nPos = 0;
	m_nLower = 0;
	m_nUpper = 100;
	m_TextString = "";
	m_BkColor = GetSysColor(COLOR_BTNFACE);
	m_TxtColor = GetSysColor(COLOR_BTNTEXT);
	m_BarColor = RGB( 0,255,255);
	m_LEDColor = RGB( 0,255,0);
	
	CWnd::PreSubclassWindow();
}

void CStatusCtrl::OnPaint() 
{
CDC MemDC;
CRect rClient;
CRect rLED;
CRect rLEDBlock;
CRect rProg;
CPaintDC dc(this); // device context for painting
//create various rectangles for all the viewable thingys
	GetClientRect( rClient );	
	rLEDBlock.SetRect(rClient.right-rClient.Height(),rClient.top,rClient.right,rClient.bottom);
	rProg.SetRect( rClient.left,rClient.top,rClient.right-rClient.Height(),rClient.bottom);
	rLED.SetRect(rLEDBlock.left+3,rLEDBlock.top+3,rLEDBlock.right-3,rLEDBlock.bottom-3);

	if( m_bmImage.m_hObject != NULL )	// delete old bitmap object
		m_bmImage.DeleteObject();
//create a new bitmap with current screen DC settings
	m_bmImage.CreateCompatibleBitmap(&dc,rClient.Width(),rClient.Height() );
//create memory DC pointer to the image bitmap
	MemDC.CreateCompatibleDC( &dc);
	CBitmap* pbmOld = MemDC.SelectObject( &m_bmImage );

//Create 2 rectangles for the progress bar depending upon m_nPos. 	
	UINT nRange = m_nUpper - m_nLower;
	CRect rLeft = rProg;
	CRect rRight = rProg;
	rLeft.right = (rProg.Width()*(m_nPos-m_nLower))/nRange;
	rRight.left = rLeft.right;

//Create two corresponding regions for use in clipping the text areas
	CRgn rgnLeft,rgnRight,rgnLED;
	rgnLeft.CreateRectRgnIndirect(rLeft);
	rgnRight.CreateRectRgnIndirect(rRight);
	rgnLED.CreateEllipticRgnIndirect(rLED);

//Fill Progress bar with bar color
	MemDC.FillSolidRect(rLeft,m_BarColor);
//Fill non Progress bar with background color
	MemDC.FillSolidRect(rRight,m_BkColor);
//Fill round LED area with color and the background black
	MemDC.FillSolidRect(rLEDBlock,GetSysColor(COLOR_BTNFACE) );
	MemDC.SelectClipRgn(&rgnLED);
	MemDC.FillSolidRect(rLED,m_LEDColor);

//Draw with normal text color the part NOT under the progress bar
	MemDC.SelectClipRgn(&rgnRight);
	MemDC.SetBkMode(TRANSPARENT);
	MemDC.SetTextColor( m_TxtColor );
	MemDC.DrawText(m_TextString, rProg,DT_VCENTER|DT_SINGLELINE|DT_CENTER);

//Draw with backgrnd color the part under the progress bar
	MemDC.SelectClipRgn(&rgnLeft);
	MemDC.SetTextColor( GetSysColor(COLOR_BACKGROUND) );
	MemDC.DrawText(m_TextString, rProg,DT_VCENTER|DT_SINGLELINE|DT_CENTER);

// Copy bitmap into screen context
	dc.BitBlt(	rClient.left, rClient.top,		//dest left,top
				rClient.right,	rClient.bottom,	//dest width, Height
				&MemDC,							//src dc
				0,0,							//src left, top
				SRCCOPY);
//deselect bitmap
	MemDC.SelectObject( pbmOld );	// from DC
	dc.DrawEdge(rClient, EDGE_ETCHED /*EDGE_SUNKEN*/,BF_RECT);
}

